/* Parser koji racuna vrednost algebarskog izraza i ispisuje ga u postfiksnom obliku 
 Koriscena tehnika rekurzivnog spusta. */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "tokeni.h"

void greska(char* m){
	fprintf(stderr,"%s\n",m);
	exit(EXIT_FAILURE);
}

//#define ISPIS 

int yylval;

extern int yylex();

int e();
int ep();
int t();
int tp();
int f();

int preduvid;

int main(){
	int rezultat;
	preduvid = yylex();
	rezultat = e();
	if(preduvid !=EOI)
		greska("Previse tokena na ulazu!\n");
	
	printf("\n\nIspravan algebarski izraz i ima vrednost %d!\n", rezultat);
	return 0;
}

int e(){
	if(preduvid == BROJ || preduvid == OZ ){
#ifdef ISPIS
		printf("e => t ep\n");
#endif
		return t() + ep();
	}
	else{
		greska("Sintaksna greska: Ocekivalo se BROJ ili (\n");
	}	
	return 0;
}

int ep(){
	if(preduvid == PLUS){
#ifdef ISPIS
		printf("ep => + t ep\n");
#endif
		preduvid = yylex();
		int pom = t();
		printf("+ ");
		return pom +	ep();
	}
	else if( preduvid == ZZ || preduvid == EOI){
#ifdef ISPIS
		printf("ep => eps\n");
#endif		
		return 0;
	}
	else greska("Sintaksna greska: Ocekivalo se EOI ili ) ili +\n");

	return 0;
}


int t(){
	if(preduvid == OZ || preduvid == BROJ){
#ifdef ISPIS
		printf("t => f tp\n");
#endif		
		return f() * tp();
	}
	else greska("Sintaksna greska: Ocekivalo se ( ili BROJ\n");	

	return 0;
}

int tp(){
	if(preduvid == PUTA){
#ifdef ISPIS
		printf("tp => * f tp\n");
#endif		
		int pom;
		preduvid = yylex();
		 pom=f();
		printf("* ");
		return pom *	tp();
	}
	else if( preduvid == PLUS || preduvid ==ZZ || preduvid == EOI){
#ifdef ISPIS
		printf("tp =>eps\n");
#endif		
		return 1;
	}
	else greska("Sintaksna greska: Ocekivalo se *, +, ), EOI");
	return 0;	
}

int f(){
	if(preduvid == OZ){
#ifdef ISPIS
		printf("f => ( e )\n");
#endif		
		int pom;
		preduvid = yylex();
		pom = e();
		if(preduvid != ZZ)
			greska("Sintaksna greska: Ocekivalo se )\n");
	
		preduvid = yylex();
		return pom;
	}
	else
		if(preduvid == BROJ){
#ifdef ISPIS
		printf("f => BROJ\n");
#endif			
			preduvid = yylex();
			printf("%d ",yylval);
			return yylval;
		}
		else greska("Sintaksna greska: Ocekivalo se ( ili BROJ\n");
		return 0;	
}
