/*******************************
*  Gramatika je:
*  e -> e+t
*	|t
*  t -> t*f
*	|f
*  f => (e)
*	|BROJ
*  Moramo se obavezno osloboditi leve rekurzije
*  pravila	skupovi izbora
*  e -> te'	{ BROJ , ( }
*  e'->	+te'	{ + }
*	|eps	{ ) , EOI }
*  t -> ft'	{ ( , BROJ }
*  t'-> *ft'	{ * }
*	|eps	{ + , ) , EOI }
*  f -> (e)	{ ( }
*	|BROJ	{ BROJ }
*  Skupove izbora smo dobili za sva pravila koja nisu epsilon
*  na osnovu skupova PRVI, a za epsilon pravila na osnovu
*  skupova SLEDI
*
*  Zadatak 3.c hocemo da prosirimo tako da program ispisuje
*  taj aritmeticki izraz, ali u postfiksnoj notaciji
*  Npr 2+3 ispisuje 2 3 +
*  Npr 2+3*4 ispisuje 2 3 4 * +
*  Akcije koji dodajemo pravilima cemo pisati u okviru pravila
*  jer cemo time precizirati kada se akcije izvrsavaju u samom pravilu
*  pravila			skupovi izbora
*  e -> te'			{ BROJ , ( }
*  e'->	+t{print(+)}e'		{ + }
*	|eps			{ ) , EOI }
*  t -> ft'			{ ( , BROJ }
*  t'-> *f{print(*)}t'		{ * }
*	|eps			{ + , ) , EOI }
*  f -> (e)			{ ( }
*	|BROJ{print(BROJ.v)}	{ BROJ }
*******************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define BROJ 1
#define PLUS 2
#define PUTA 3
#define LZ 4
#define DZ 5
#define EOI 0

#define ISPIS 1
int preduvid;

void e();
void ep();
void t();
void tp();
void f();

void greska(char* s){
	fprintf(stderr,"%s\n",s);
	exit(EXIT_FAILURE);
}

int yyval;

/*samostalno pisemo leksicki analizator*/
int yylex(){
	char ch =getchar();
	switch(ch){
	case '+':
		return PLUS;
	case '*':
		return PUTA;
	case '(':
		return LZ;
	case ')':
		return DZ;
	case '\n':
	case EOF:
		return EOI;
	} 
	/* ako smo procitali cifru ?*/
	if(isdigit(ch)){
		yyval =ch -'0';
		while(isdigit(ch=getchar()))
			yyval = yyval *10 +ch -'0';
	
		ungetc(ch, stdin);
		return BROJ;
	}
	
	greska("Leksicka greska: nepoznata leksema!");
	return -1;
}


void e(){
	if(preduvid == BROJ || preduvid == LZ){
#ifndef ISPIS
	printf("e --> t ep\n");
#endif
	t();
	ep();
	}
	else greska("Sintaksna greska: Ocekivan je token BROJ ili LZ.");
}

void ep(){
	if (preduvid== PLUS){
#ifndef ISPIS
	printf("ep --> + t ep\n");
#endif
	preduvid = yylex();
	t();
	printf(" + ");
	ep();
	}
	else if(preduvid == DZ || preduvid == EOI){
#ifndef ISPIS
		printf("ep --> eps\n");
#endif
		return;
	}
	else greska("Sintaksan greska: Ocekivan je token PLUS ili DZ ili EOI");
}

void t(){
	if(preduvid == LZ || preduvid == BROJ){
#ifndef ISPIS
	printf("t --> f tp\n");
#endif
	f();
	tp();
	}
	else greska("Sintaksna greska: Ocekivano je LZ ili BROJ.");
}

void tp(){
	if(preduvid == PUTA){
#ifndef ISPIS
	printf("tp --> * f tp\n");
#endif
	preduvid= yylex();
	f();
	printf(" * ");
	tp();
	}
	else if(preduvid == PLUS || preduvid == DZ || preduvid == EOI){
#ifndef ISPIS
	printf("tp --> eps\n");
#endif
	return;
	}
	else greska("Sintaksan greska:NEocekivani token");
}

void f(){
	if(preduvid == LZ){
#ifndef ISPIS
	printf("f --> (e)\n");
#endif
	preduvid = yylex();
	e();
	if(preduvid == DZ)
		preduvid = yylex();
	else greska("Sintaksna greska: Ocekivano je DZ.");
	}
	else if(preduvid == BROJ){
#ifndef ISPIS
	printf("f --> BROJ\n");
#endif
	preduvid = yylex();
	printf("%d ",yyval);
	return;
	}
}

int main(){
	preduvid = yylex();

	e();
	if(preduvid!=EOI)
		greska("Sintaksna greska: VIsak karaktera na ulazu!");
	return 0;
}

